<?php
namespace Zeedhi\DevOps\Model\Devops\Repositories;

use Doctrine\DBAL\Connection;

class ProductFilesMnemonic extends \Doctrine\ORM\EntityRepository {
    
    public function findMnemonicNotInScript($mnemonics,$productFileId)
    {
        $filterEmptyMnemonic = '';
        if(empty($mnemonics)) {
            $filterEmptyMnemonic = 'OR :MNEMONICS IS NULL';
        }

        $query = <<<SQL
		   SELECT MNE.ID
             FROM PRODUCT_FILES_MNEMONIC PFM
        LEFT JOIN MNEMONIC MNE ON(MNE.ID = PFM.MNEMONIC_ID)
            WHERE PFM.PRODUCT_FILES_ID = :PRODUCT_FILE_ID
              AND (MNE.MNEMONIC NOT IN (:MNEMONICS) $filterEmptyMnemonic)
SQL;
        $params = array(
            'MNEMONICS' => $mnemonics,
            'PRODUCT_FILE_ID' => $productFileId,
        );
        $paramTypes = array(
            'MNEMONICS' => Connection::PARAM_STR_ARRAY,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params, $paramTypes);
    }
}